diff --git a/game/client/src/main/java/net/minecraft/client/gui/worldsettings/settingnode/BooleanValueNodeComponent.java b/game/client/src/main/java/net/minecraft/client/gui/worldsettings/settingnode/BooleanValueNodeComponent.java
new file mode 100644
index 000000000..e7583d960
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/gui/worldsettings/settingnode/BooleanValueNodeComponent.java
@@ -0,0 +1,57 @@
+package net.minecraft.client.gui.worldsettings.settingnode;
+
+import net.minecraft.client.gui.SwitchElement;
+import net.minecraft.core.world.Dimension;
+import net.minecraft.core.world.settings.ValueSettingNode;
+import net.minecraft.core.world.settings.WorldConfiguration;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+public class BooleanValueNodeComponent extends ValueNodeComponent<@NotNull Boolean> {
+    private final @NotNull SwitchElement button;
+
+    public BooleanValueNodeComponent(final @NotNull ValueSettingNode<@NotNull Boolean> valueNode, final int nestLevel) {
+        super(valueNode, nestLevel);
+
+        this.button = new SwitchElement(0, 0, 0, 150, 20, false, "", "");
+    }
+
+    @Override
+    public void reset() {
+        super.reset();
+        this.onChange();
+    }
+
+    @Override
+    public void onUpdate(final @NotNull Dimension dimension, final @NotNull WorldConfiguration worldConfiguration) {
+        super.onUpdate(dimension, worldConfiguration);
+        this.onChange();
+    }
+
+    @Override
+    protected boolean buttonClicked(final int mouseButton, final int x, final int y, final int width, final int height, final int relativeMouseX, final int relativeMouseY) {
+        final @Nullable Dimension dimension = this.getDimension();
+        final @Nullable WorldConfiguration worldConfiguration = this.getWorldConfiguration();
+        assert dimension != null && worldConfiguration != null;
+
+        worldConfiguration.getDimensionSettings(dimension).setNodeValue(this.getNode(), !worldConfiguration.getDimensionSettings(dimension).getNodeValue(this.getNode(), worldConfiguration));
+        this.onChange();
+
+        return true;
+    }
+
+    @Override
+    protected void renderButtonInner(final int x, final int y, final int relativeButtonX, final int relativeButtonY, final int buttonWidth, final int buttonHeight, final int relativeMouseX, final int relativeMouseY) {
+        this.button.xPosition = x + relativeButtonX;
+        this.button.yPosition = y + relativeButtonY;
+        this.button.width = buttonWidth;
+        this.button.height = buttonHeight;
+
+        this.button.drawButton(MC, x + relativeMouseX, y + relativeMouseY);
+    }
+
+    private void onChange() {
+        this.button.setOn(this.getValue());
+        this.button.displayString = this.getNode().getValueText(this.getValue()).toString();
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/gui/worldsettings/settingnode/CategoryComponent.java b/game/client/src/main/java/net/minecraft/client/gui/worldsettings/settingnode/CategoryComponent.java
new file mode 100644
index 000000000..a943ca170
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/gui/worldsettings/settingnode/CategoryComponent.java
@@ -0,0 +1,139 @@
+package net.minecraft.client.gui.worldsettings.settingnode;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.ItemElement;
+import net.minecraft.client.gui.options.components.OptionsComponent;
+import net.minecraft.client.gui.paged.PageComponent;
+import net.minecraft.client.gui.paged.ScreenPaged;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.lang.text.Text;
+import net.minecraft.core.sound.SoundCategory;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.ArrayList;
+import java.util.List;
+
+public class CategoryComponent implements PageComponent {
+    private static final Minecraft MC = Minecraft.getMinecraft();
+    private static final ItemElement RENDER_ITEM = new ItemElement(MC);
+    private static final int PADDING = 2;
+    private static final int TOP_SPACING = PADDING + 10 + 10 + PADDING;
+    private static final int COMPONENT_LEFT_MARGIN = 16;
+
+    private final @NotNull Text label;
+    private final @Nullable ItemStack icon;
+    private final @NotNull List<@NotNull PageComponent> components = new ArrayList<>();
+
+    private @Nullable PageComponent clickedComponent = null;
+    private int clickedComponentY = 0;
+
+    private boolean collapsed = false;
+
+    public CategoryComponent(final @NotNull Text label, final @Nullable ItemStack icon) {
+        this.label = label;
+        this.icon = icon;
+    }
+
+    public CategoryComponent(final @NotNull Text label) {
+        this(label, null);
+    }
+
+    public @NotNull CategoryComponent withComponent(final @NotNull PageComponent component) {
+        this.components.add(component);
+
+        return this;
+    }
+
+    @Override
+    public void tick() {
+        for (final @NotNull PageComponent component : this.components) {
+            component.tick();
+        }
+    }
+
+    @Override
+    public int getHeight() {
+        int height = TOP_SPACING;
+        if (!this.collapsed) {
+            for (final @NotNull PageComponent component : this.components) {
+                height += component.getHeight();
+            }
+        }
+        return height;
+    }
+
+    @Override
+    public void render(final @NotNull ScreenPaged screen, final int x, final int y, final int width, final int relativeMouseX, final int relativeMouseY) {
+        final int textColor = 0x7F7F7F;
+        MC.font.render((this.collapsed ? "▷" : "▽"), x, y + PADDING + 10).setShadow().setColor(textColor).call();
+
+        int xOffset = 10;
+        if (this.icon != null) {
+            RENDER_ITEM.render(this.icon, x + 11, y + PADDING + 5);
+            xOffset += 20;
+        }
+        MC.font.render(this.label.toString(), x + xOffset, y + PADDING + 10).setShadow().setColor(textColor).call();
+        if (!this.collapsed) {
+            int componentY = TOP_SPACING;
+            for (final @NotNull PageComponent component : this.components) {
+                if (y + componentY + component.getHeight() >= screen.top() && y + componentY <= screen.bottom()) {
+                    component.render(screen, x + COMPONENT_LEFT_MARGIN, y + componentY, width - COMPONENT_LEFT_MARGIN, relativeMouseX - COMPONENT_LEFT_MARGIN, relativeMouseY - componentY);
+                }
+                componentY += component.getHeight();
+            }
+        }
+    }
+
+    @Override
+    public boolean onMouseClick(final int mouseButton, final int x, final int y, final int width, final int relativeMouseX, final int relativeMouseY) {
+        if (relativeMouseX >= 0 && relativeMouseX < width && relativeMouseY >= 0 && relativeMouseY < TOP_SPACING) {
+            this.collapsed = !this.collapsed;
+            MC.sndManager.playSound("random.click", SoundCategory.GUI_SOUNDS, 1.0F, 1.0F);
+        }
+
+        int componentY = TOP_SPACING;
+        for (final @NotNull PageComponent component : this.components) {
+            if (relativeMouseX >= COMPONENT_LEFT_MARGIN && relativeMouseX < width && relativeMouseY >= componentY && relativeMouseY < componentY + component.getHeight()) {
+                component.onMouseClick(mouseButton, x + COMPONENT_LEFT_MARGIN, componentY, width - COMPONENT_LEFT_MARGIN, relativeMouseX - COMPONENT_LEFT_MARGIN, relativeMouseY - componentY);
+                this.clickedComponent = component;
+                this.clickedComponentY = componentY;
+                return true;
+            }
+            componentY += component.getHeight();
+        }
+
+        return false;
+    }
+
+    @Override
+    public boolean onMouseMove(final int x, final int y, final int width, final int relativeMouseX, final int relativeMouseY) {
+        if (this.clickedComponent != null) {
+            return this.clickedComponent.onMouseMove(x + COMPONENT_LEFT_MARGIN, this.clickedComponentY, width - COMPONENT_LEFT_MARGIN, relativeMouseX - COMPONENT_LEFT_MARGIN, relativeMouseY - this.clickedComponentY);
+        }
+
+        return false;
+    }
+
+    @Override
+    public boolean onMouseRelease(final int mouseButton, final int x, final int y, final int width, final int relativeMouseX, final int relativeMouseY) {
+        if (this.clickedComponent != null) {
+            return this.clickedComponent.onMouseRelease(mouseButton, x + COMPONENT_LEFT_MARGIN, this.clickedComponentY, width - COMPONENT_LEFT_MARGIN, relativeMouseX - COMPONENT_LEFT_MARGIN, relativeMouseY - this.clickedComponentY);
+        }
+
+        return false;
+    }
+
+    @Override
+    public void onKeyPress(final int keyCode, final char character) {
+        for (final @NotNull PageComponent component : this.components) {
+            component.onKeyPress(keyCode, character);
+        }
+    }
+
+    @Override
+    public boolean matchesSearchTerm(final String term) {
+        return false;
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/gui/worldsettings/settingnode/ListValueNodeComponent.java b/game/client/src/main/java/net/minecraft/client/gui/worldsettings/settingnode/ListValueNodeComponent.java
new file mode 100644
index 000000000..ff79936b2
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/gui/worldsettings/settingnode/ListValueNodeComponent.java
@@ -0,0 +1,85 @@
+package net.minecraft.client.gui.worldsettings.settingnode;
+
+import net.minecraft.client.gui.ButtonElement;
+import net.minecraft.client.gui.popup.PopupBuilder;
+import net.minecraft.client.gui.popup.PopupScreen;
+import net.minecraft.core.lang.text.Text;
+import net.minecraft.core.world.Dimension;
+import net.minecraft.core.world.settings.ListValueSettingNode;
+import net.minecraft.core.world.settings.ValueSettingNode;
+import net.minecraft.core.world.settings.WorldConfiguration;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.List;
+import java.util.Objects;
+
+public class ListValueNodeComponent<T> extends ValueNodeComponent<T> {
+    private final @NotNull ButtonElement button;
+
+    public ListValueNodeComponent(final @NotNull ListValueSettingNode<T> valueNode, final int nestLevel) {
+        super(valueNode, nestLevel);
+
+        this.button = new ButtonElement(0, 0, 0, 150, 20, "");
+    }
+
+    @Override
+    public void reset() {
+        super.reset();
+        this.button.displayString = this.getNode().getValueText(this.getValue()).toString();
+    }
+
+    @Override
+    public void onUpdate(final @NotNull Dimension dimension, final @NotNull WorldConfiguration worldConfiguration) {
+        super.onUpdate(dimension, worldConfiguration);
+        this.button.displayString = this.getNode().getValueText(this.getValue()).toString();
+    }
+
+    @Override
+    protected boolean buttonClicked(final int mouseButton, final int x, final int y, final int width, final int height, final int relativeMouseX, final int relativeMouseY) {
+        final @NotNull ListValueSettingNode<T> node = (ListValueSettingNode<T>) this.getNode();
+        final @Nullable Dimension dimension = this.getDimension();
+        final @Nullable WorldConfiguration worldConfiguration = this.getWorldConfiguration();
+        assert dimension != null && worldConfiguration != null;
+
+        final @NotNull T currentValue = this.getValue();
+
+        int selected = 0;
+        final @NotNull List<@NotNull T> values = node.getValues(dimension, worldConfiguration);
+        final @NotNull String @NotNull [] keys = new String[values.size()];
+        for (int i = 0; i < keys.length; i++) {
+            final @NotNull T value = values.get(i);
+            final @NotNull Text valueText = node.getValueText(value);
+            keys[i] = valueText.toString();
+
+            if (value == currentValue || value.equals(currentValue) || currentValue.equals(value)) {
+                selected = i;
+            }
+        }
+
+        final @NotNull PopupScreen popup = new PopupBuilder(Objects.requireNonNull(MC.currentScreen), 150)
+            .closeOnEsc(0)
+            .closeOnClickOut(0)
+            .withList("settingList", 140, keys, null, selected, true)
+            .withOnCloseListener((statusCode, results) -> {
+                if (statusCode == 1) {
+                    final int index = (Integer) Objects.requireNonNull(results.get("settingList"));
+                    this.getWorldConfiguration().getDimensionSettings(Objects.requireNonNull(this.getDimension())).setNodeValue(node, values.get(index));
+                }
+            })
+            .build();
+        MC.displayScreen(popup);
+
+        return true;
+    }
+
+    @Override
+    protected void renderButtonInner(final int x, final int y, final int relativeButtonX, final int relativeButtonY, final int buttonWidth, final int buttonHeight, final int relativeMouseX, final int relativeMouseY) {
+        this.button.xPosition = x + relativeButtonX;
+        this.button.yPosition = y + relativeButtonY;
+        this.button.width = buttonWidth;
+        this.button.height = buttonHeight;
+
+        this.button.drawButton(MC, x + relativeMouseX, y + relativeMouseY);
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/gui/worldsettings/settingnode/NestedNodeComponent.java b/game/client/src/main/java/net/minecraft/client/gui/worldsettings/settingnode/NestedNodeComponent.java
new file mode 100644
index 000000000..b433c459c
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/gui/worldsettings/settingnode/NestedNodeComponent.java
@@ -0,0 +1,205 @@
+package net.minecraft.client.gui.worldsettings.settingnode;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.paged.ScreenPaged;
+import net.minecraft.client.gui.worldsettings.NodeComponent;
+import net.minecraft.client.gui.worldsettings.settingnode.conversion.NodeAdapterRegistry;
+import net.minecraft.client.render.renderer.BlendFactor;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.Shaders;
+import net.minecraft.client.render.renderer.State;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
+import net.minecraft.core.world.Dimension;
+import net.minecraft.core.world.settings.SettingNode;
+import net.minecraft.core.world.settings.SettingNodeChildrenProvider;
+import net.minecraft.core.world.settings.WorldConfiguration;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.ArrayList;
+import java.util.List;
+
+public class NestedNodeComponent implements NodeComponent {
+    protected static final @NotNull Minecraft MC = Minecraft.getMinecraft();
+    protected static final int COMPONENT_SPACING = 2;
+    private static final int NEST_LEFT_MARGIN = 16;
+
+    private final int nestLevel;
+    private final @NotNull SettingNode node;
+    private final @NotNull List<@NotNull NodeComponent> components = new ArrayList<>();
+
+    private @Nullable Dimension dimension = null;
+    private @Nullable WorldConfiguration worldConfiguration = null;
+    private @Nullable NodeComponent clickedComponent = null;
+    private int clickedComponentY = 0;
+
+    public NestedNodeComponent(final @NotNull SettingNode node, final int nestLevel) {
+        this.node = node;
+        this.nestLevel = nestLevel;
+    }
+
+    protected @Nullable Dimension getDimension() {
+        return this.dimension;
+    }
+
+    protected @Nullable WorldConfiguration getWorldConfiguration() {
+        return this.worldConfiguration;
+    }
+
+    @Override
+    public void reset() {
+        for (final @NotNull NodeComponent component : this.components) {
+            component.reset();
+        }
+    }
+
+    @Override
+    public int getNestLevel() {
+        return this.nestLevel;
+    }
+
+    @Override
+    public void onUpdate(final @NotNull Dimension dimension, final @NotNull WorldConfiguration worldConfiguration) {
+        this.dimension = dimension;
+        this.worldConfiguration = worldConfiguration;
+
+        this.components.clear();
+        final @Nullable SettingNodeChildrenProvider childrenProvider = this.node.getChildrenProvider();
+        if (childrenProvider != null && this.getNode().areChildrenVisible(this.dimension, this.worldConfiguration)) {
+            for (final @NotNull SettingNode child : childrenProvider) {
+                if (child.isVisible(dimension, worldConfiguration)) {
+                    final @NotNull NodeComponent childComponent = NodeAdapterRegistry.adapt(child, this.nestLevel + this.getNestLevelContribution());
+                    childComponent.onUpdate(dimension, worldConfiguration);
+                    this.components.add(childComponent);
+                }
+            }
+        }
+    }
+
+    @Override
+    public @NotNull SettingNode getNode() {
+        return this.node;
+    }
+
+    public int getNestLevelContribution() {
+        return 0;
+    }
+
+    public int getBaseHeight() {
+        return COMPONENT_SPACING;
+    }
+
+    @Override
+    public void tick() {
+        for (final @NotNull NodeComponent child : this.components) {
+            child.tick();
+        }
+    }
+
+    @Override
+    public int getHeight() {
+        int height = this.getBaseHeight();
+        for (final @NotNull NodeComponent component : this.components) {
+            height += component.getHeight();
+        }
+
+        return height;
+    }
+
+    @Override
+    public void render(final @NotNull ScreenPaged screen, final int x, final int y, final int width, final int relativeMouseX, final int relativeMouseY) {
+        final int childrenHeight = this.getHeight() - this.getBaseHeight();
+        if (childrenHeight > 0) {
+            int alpha = 0x80 * (this.nestLevel + this.getNestLevelContribution());
+            if (alpha > 0xFF) {
+                alpha = 0xFF;
+            }
+
+            if (alpha > 0) {
+                alpha = alpha << 24;
+                this.drawRect(x - (NEST_LEFT_MARGIN * (this.nestLevel + this.getNestLevelContribution())), y + this.getBaseHeight(), x + width + 16, y + this.getBaseHeight() + childrenHeight, alpha);
+            }
+        }
+
+        int componentY = this.getBaseHeight();
+        for (final @NotNull NodeComponent component : this.components) {
+            if (y + componentY + component.getHeight() >= screen.top() && y + componentY <= screen.bottom()) {
+                component.render(screen, x + NEST_LEFT_MARGIN * component.getNestLevel(), y + componentY, width - NEST_LEFT_MARGIN * component.getNestLevel(), relativeMouseX - NEST_LEFT_MARGIN * component.getNestLevel(), relativeMouseY - componentY);
+            }
+            componentY += component.getHeight();
+        }
+    }
+
+    @Override
+    public boolean onMouseClick(final int mouseButton, final int x, final int y, final int width, final int relativeMouseX, final int relativeMouseY) {
+        int componentY = this.getBaseHeight();
+        for (final @NotNull NodeComponent component : this.components) {
+            if (relativeMouseX >= NEST_LEFT_MARGIN * component.getNestLevel() && relativeMouseX < width && relativeMouseY >= componentY && relativeMouseY < componentY + component.getHeight()) {
+                component.onMouseClick(mouseButton, x + NEST_LEFT_MARGIN * component.getNestLevel(), componentY, width - NEST_LEFT_MARGIN * component.getNestLevel(), relativeMouseX - NEST_LEFT_MARGIN * component.getNestLevel(), relativeMouseY - componentY);
+                this.clickedComponent = component;
+                this.clickedComponentY = componentY;
+                return true;
+            }
+            componentY += component.getHeight();
+        }
+
+        this.clickedComponent = null;
+        return false;
+    }
+
+    @Override
+    public boolean onMouseMove(final int x, final int y, final int width, final int relativeMouseX, final int relativeMouseY) {
+        if (this.clickedComponent != null) {
+            this.clickedComponent.onMouseMove(x + NEST_LEFT_MARGIN * this.clickedComponent.getNestLevel(), this.clickedComponentY, width - NEST_LEFT_MARGIN * this.clickedComponent.getNestLevel(), relativeMouseX - NEST_LEFT_MARGIN * this.clickedComponent.getNestLevel(), relativeMouseY - this.clickedComponentY);
+            return true;
+        }
+
+        return false;
+    }
+
+    @Override
+    public boolean onMouseRelease(final int mouseButton, final int x, final int y, final int width, final int relativeMouseX, final int relativeMouseY) {
+        if (this.clickedComponent != null) {
+            this.clickedComponent.onMouseRelease(mouseButton, x + NEST_LEFT_MARGIN * this.clickedComponent.getNestLevel(), this.clickedComponentY, width - NEST_LEFT_MARGIN * this.clickedComponent.getNestLevel(), relativeMouseX - NEST_LEFT_MARGIN * this.clickedComponent.getNestLevel(), relativeMouseY - this.clickedComponentY);
+            this.clickedComponent = null;
+            return true;
+        }
+
+        return false;
+    }
+
+    @Override
+    public void onKeyPress(final int keyCode, final char character) {
+        for (final @NotNull NodeComponent component : this.components) {
+            component.onKeyPress(keyCode, character);
+        }
+    }
+
+    @Override
+    public void onClose() {
+        for (final @NotNull NodeComponent component : this.components) {
+            component.onClose();
+        }
+    }
+
+    @Override
+    public boolean matchesSearchTerm(final String term) {
+        return false;
+    }
+
+    protected void drawRect(final int minX, final int minY, final int maxX, final int maxY, final int argb) {
+        GLRenderer.pushFrame();
+        GLRenderer.setShader(Shaders.COLOR);
+        GLRenderer.enableState(State.BLEND);
+        GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
+        final TessellatorGeneral tessellator = GLRenderer.getTessellator();
+        tessellator.startDrawingQuads();
+        tessellator.setColor2i(argb & 0x00FFFFFF, argb >> 24 & 0xff);
+        tessellator.addVertex(minX, maxY, 0.0D);
+        tessellator.addVertex(maxX, maxY, 0.0D);
+        tessellator.addVertex(maxX, minY, 0.0D);
+        tessellator.addVertex(minX, minY, 0.0D);
+        tessellator.draw();
+        GLRenderer.popFrame();
+    }
+}
